Speedup Project Settings with many members
Status: Closed Start date:  

Priority: Normal Due date:  

Assignee:  % Done: 0%

Category: Performance Estimated time: 0.00 hour

Target version:    

Description

Hi,

There is a .sort in _members.html.erb partial that take a lot of time for project that have more than 12s to execute, so I change for

.order('roles.builtin, roles.position, users.firstname, users.lastname')

- members = @project.memberships.active.includes(:member_roles, :roles, :principal).to_a.sort

+ members = @project.memberships.active.includes(:member_roles, :roles, :principal).order('roles.b

uiltin, roles.position, users.firstname, users.lastname')

 
Benchmark.measure { project.memberships.active.includes(:member_roles, :roles, :principal).order('

roles.builtin, roles.position, users.firstname, users.lastname').to_a }

#<Benchmark::Tms:0x00000008a427e0 @label="", @real=0.7370121359999757, @cstime=0.0, @cutime=0.0, @

stime=0.0, @utime=0.6500000000000004, @total=0.6500000000000004>

Benchmark.measure { project.memberships.active.includes(:member_roles, :roles, :principal).to_a.so

rt }

#<Benchmark::Tms:0x0000000c68f450 @label="", @real=12.094179325009463, @cstime=0.0, @cutime=0.0, @

stime=0.019999999999999962, @utime=12.029999999999998, @total=12.049999999999997>

History

#1 - 2016-07-29 07:45 - Go MAEDA

Interesting. Reducing 12 sec to 0.6 sec is big improvement. How many members on the project?

Here is a diff made from the first post.

Index: app/views/projects/settings/_members.html.erb

===================================================================

--- app/views/projects/settings/_members.html.erb    (revision 15732)

+++ app/views/projects/settings/_members.html.erb    (working copy)

@@ -1,5 +1,5 @@

 <% roles = Role.find_all_givable

-   members = @project.memberships.active.includes(:member_roles, :roles, :principal).to_a.sort %>

+   members = @project.memberships.active.includes(:member_roles, :roles, :principal).order('roles.builtin, ro

les.position, users.firstname, users.lastname')

 <p><%= link_to l(:label_member_new), new_project_membership_path(@project), :remote => true, :class => "icon 

icon-add" %></p>

#2 - 2016-07-29 14:09 - Victor Campos

6K members

#3 - 2016-08-18 06:37 - Toshi MARUYAMA

I think SQL "users.firstname, users.lastname" order is not acceptable because AFAIK user sort is configurable.

source:tags/3.3.0/app/models/user.rb#L24

#4 - 2024-01-20 09:59 - Go MAEDA

- Status changed from New to Closed

Closing this issue for the reason described in #note-3.
https://www.redmine.org/projects/redmine/repository/svn/entry/tags/3.3.0/app/models/user.rb#L24


#5 - 2024-01-20 13:23 - Holger Just

This was already fixed in Redmine 3.4.0 with r16040 by using Principal.fields_for_order_statement
https://www.redmine.org/versions/119
https://www.redmine.org/projects/redmine/repository/svn/revisions/16040
